/*
 * $Id$
 */
package gui;

import java.awt.Canvas;
import java.awt.Color;
import java.awt.Graphics;

import simulation.Environment;
import simulation.Feld;
import simulation.Karte;

/**
 * @author Kai Sterker
 *
 */
public class MapView extends Canvas {
	public final static int WORLD_VIEW = 0;
	public final static int AGENT_VIEW = 1;

	private int size;
	private int ansicht;
	private Environment umgebung = null;
	private Color[] farbe = {
		new Color (255, 255, 255, 255),
		new Color (118, 229, 65),
		new Color (228, 234, 65),
		new Color (229, 96, 65)
	};
	private String[] objekte = { "pit", "wumpus", "stench", "breeze", 
		"agent_n", "agent_e", "agent_s", "agent_w", "gold" };
	
	public MapView (int size, int ansicht) {
		this.ansicht = ansicht;
		this.size = size;
		this.setSize (size, size);
		this.setBackground (farbe[0]);
	}
	
	public void setUmgebung (Environment umgebung) {
		this.umgebung = umgebung;
	}
	
	public void paint (Graphics g) {
		int step = size / 4;
		for (int x = 0; x < 4; x++)
			for (int y = 0; y < 4; y++) {
				if (umgebung != null) {
					Karte k = umgebung.getKarte (ansicht);
					Feld feld = k.getFeld (y, x);
					
					if (feld.getFarbe() != 0) {
						g.setColor(farbe[feld.getFarbe ()]);
						g.fillRect (x * step, y * step, step, step);
						g.setColor(Color.BLACK);
						g.drawString (y + ", " + x, x*step + 20, y*step + 20);
					}
					
					if (feld.isUnveraendert ()) continue;
					else paint (g, feld, x * step, y * step, step);
				}
				g.drawLine (x * step, y * step, x * step, size);
				g.drawLine (x * step, y * step, size, y * step);				
			}
	}
	
	private void paint (Graphics g, Feld feld, int x, int y, int s) {
		for (int i = 0; i < objekte.length; i++)
			if (feld.enthaelt (objekte[i]))
				g.drawImage (GrafikCache.getGrafik(objekte[i]), 
					x, y, s, s, farbe[feld.getFarbe ()], this);
	}
}
