/*
 * $Id$
 */
package simulation;

import java.util.Random;
import java.util.Vector;

/**
 * @author kai
 *
 */
public class Karte {
	private Feld[][] felder = new Feld[4][4];

	public Karte (int farbe) {
		for (int i = 0; i < 4; i++)
			for (int j = 0; j < 4; j++)
				felder[i][j] = new Feld (farbe);
	}
	
	public void standartWelt () {
		
		felder[0][3].add ("pit");
		felder[1][3].add ("breeze");
		felder[0][2].add ("breeze");
		
		felder[1][0].add ("wumpus");
		felder[0][0].add ("stench");
		felder[1][1].add ("stench");
		felder[2][0].add ("stench");
		
		felder[1][1].add ("gold");
		
		felder[1][2].add ("pit");
		felder[2][2].add ("breeze");
		felder[1][1].add ("breeze");
		
		felder[3][0].add ("agent_n");
		
		felder[3][2].add ("pit");
		felder[3][3].add ("breeze");
		felder[3][1].add ("breeze");
	}
	
	public void zufallsWelt () {
		Vector objekte = new Vector ();
		objekte.add ("pit");
		objekte.add ("pit");
		objekte.add ("pit");
		objekte.add ("wumpus");
		objekte.add ("gold");

		felder[3][0].add ("agent_n");

		Random rnd = new Random ();
		String objekt;
		
		while (!objekte.isEmpty ()) {
			int i = rnd.nextInt (objekte.size());
			int x = rnd.nextInt (4);
			int y = rnd.nextInt (4);
			
			if (x == 3 && y == 0) continue;
			
			objekt = (String) objekte.get (i);
			if (objekt.equals("wumpus")) {
				if (felder[x][y].enthaelt("gold")) continue;

				if (x > 0) felder[x-1][y].add ("stench");	
				if (x < 3) felder[x+1][y].add ("stench");	
				if (y > 0) felder[x][y-1].add ("stench");	
				if (y < 3) felder[x][y+1].add ("stench");	
			}
			else if (objekt.equals("pit")) {
				if (felder[x][y].enthaelt("gold")) continue;
				
				if (x > 0) felder[x-1][y].add ("breeze");	
				if (x < 3) felder[x+1][y].add ("breeze");	
				if (y > 0) felder[x][y-1].add ("breeze");	
				if (y < 3) felder[x][y+1].add ("breeze");	
			}
			else if (objekt.equals("gold")) {
				if (felder[x][y].enthaelt("wumpus") ||
					felder[x][y].enthaelt("pit")) continue;
			}
			felder[x][y].add (objekt);
			objekte.remove(i);		
		}
	}
	
	public Feld getFeld(int x, int y) {
		return felder[x][y];
	}

	/**
	 * @param x
	 * @param y
	 * @param objekt
	 */
	public void remove (int x, int y, String objekt) {
		felder[x][y].remove (objekt);
	}

	/**
	 * @param x
	 * @param y
	 * @param objekt
	 */
	public void add (int x, int y, String objekt) {
		felder[x][y].add (objekt);
	}

	/**
	 * @param x
	 * @param y
	 * @return
	 */
	public Wahrnehmung erzeugeWahrnehmung(int x, int y) {
		Wahrnehmung w = new Wahrnehmung ();
			
		w.hinzu (felder[x][y], true);
		if (x - 1 >= 0) w.hinzu (felder[x-1][y], false);
		if (x + 1 < 4) w.hinzu (felder[x+1][y], false);
		if (y - 1 >= 0) w.hinzu (felder[x][y-1], false);
		if (y + 1 < 4) w.hinzu (felder[x][y+1], false);
	
		return w;
	}

	/**
	 * Erzeugt eine Karte aus dem Wissen des Agenten.
	 * @param agent
	 */
	public void fromAgent (Agent agent) {
		int x = agent.getPosX () - 1;
		int y = agent.getPosY () - 1;
		
		for (int i = (x < 0 ? 0 : x); i < x + 3 && i < 4; i++)
			for (int j = (y < 0 ? 0 : y); j < y + 3 && j < 4; j++)
				paintFromAgent (agent, i, j);
	}
	
	public void initFromAgent (Agent agent) {
		for (int i = 0; i < 4; i++)
			for (int j = 0; j < 4; j++) 
				paintFromAgent (agent, i, j);
	}

	private void paintFromAgent (Agent agent, int i, int j) {
		// Felder die schon besucht waren sind unveraendert OK.
		if (felder[i][j].getFarbe() == Feld.GRUEN) return;
				
		if (agent.visited (i, j)) {				
			felder[i][j].setFarbe (Feld.GRUEN);
		}
		else {
			if (agent.dangerAt (i, j))
				felder[i][j].setFarbe (Feld.ROT);
			else
				felder[i][j].setFarbe (Feld.GELB);
		}
	}
}
